"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileWriter = void 0;
const fs_extra_1 = require("fs-extra");
const rfs = __importStar(require("rotating-file-stream"));
const path_1 = require("path");
// export interface IWriter {
//   log: (msg: string) => void
//   error: (msg: string) => void
//   link?: IWriter
// }
/**
 * Log를 파일로
 */
class FileWriter {
    /**
     * Log를 파일로
     * @param path 저장할 파일경로
     * @param interval 장기간 로그할때 파일을 따로 저장. 예: '1d'
     */
    constructor(path, interval) {
        if (interval) {
            let dir = (0, path_1.dirname)(path);
            let file = (0, path_1.basename)(path);
            (0, fs_extra_1.ensureDirSync)(dir);
            this._stream = rfs.createStream(file, {
                interval,
                path: dir,
            });
        }
        else {
            let dir = (0, path_1.dirname)(path);
            (0, fs_extra_1.ensureDirSync)(dir);
            this._stream = (0, fs_extra_1.createWriteStream)(path, {
                flags: 'a',
            });
        }
    }
    _message(type, msg) {
        this._stream.write(`\n${type}: ` + msg);
    }
    log(msg) {
        this._message('log', msg);
    }
    error(msg) {
        this._message('err', msg);
    }
    write(msg) {
        // this._stream.write(`\n${msg}`)
        if (msg instanceof Error) {
            this._stream.write(`\n${JSON.stringify({
                name: msg.name,
                message: msg.message,
                stack: msg.stack,
            }, null, 2)}`);
            return;
        }
        this._stream.write(`\n${JSON.stringify(msg, null, 2)}`);
    }
}
exports.FileWriter = FileWriter;
//# sourceMappingURL=FileWriter.js.map