export interface IWriter {
    log: (msg: string) => void;
    error: (msg: string) => void;
    write: (msg: any) => void;
    link?: IWriter;
}
/**
 * 단순 console 로그
 */
export declare class DefaultWriter implements IWriter {
    private _other;
    private _message;
    log(msg: string): void;
    error(msg: string): void;
    write(msg: any): void;
    get link(): IWriter;
    set link(other: IWriter);
}
/**
 * Log
 */
export declare class Logger {
    static get writer(): IWriter;
    static set writer(writer: IWriter);
    static get format(): string;
    static set format(format: string);
    private _name;
    /**
     * Log
     * @param name Log 이름
     */
    constructor(name?: string);
    /**
     * Log 이름. 아니면 클래스 이름
     */
    get name(): string;
    protected _makeMsg(msgs: any[]): string;
    log(...msgs: any[]): void;
    error(...msgs: any[]): void;
}
