"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MemoryWriter = void 0;
class MemoryWriter {
    constructor(limit = 1000) {
        this.limit = limit;
        this._m = [];
        this._old = [];
    }
    _check() {
        if (this._m.length >= this.limit) {
            this._old = this._m;
            this._m = [];
        }
    }
    _message(type, msg) {
        this._check();
        this._m.push(`${type}: ` + msg);
    }
    log(msg) {
        this._message('log', msg);
    }
    error(msg) {
        this._message('err', msg);
    }
    write(msg) {
        this._check();
        if (msg instanceof Error) {
            this._m.push({
                name: msg.name,
                message: msg.message,
                stack: msg.stack,
            });
            return;
        }
        this._m.push(msg);
        // switch(typeof(msg)) {
        //   case 'string': {
        //     this._m.push(msg)
        //     break
        //   }
        //   case 'number': {
        //     this._m.push(msg.toString())
        //     break
        //   }
        //   case 'boolean': {
        //     this._m.push(msg? 'true' : 'false')
        //     break
        //   }
        //   default: {
        //     this._m.push(JSON.stringify(msg))
        //   }
        // }
    }
    get memory() {
        return this._old.concat(this._m);
    }
    get last() {
        if (this._m.length === 0) {
            return '';
        }
        return this._m[this._m.length - 1];
    }
    clear() {
        this._m = [];
        this._old = [];
    }
    get link() {
        return this._other;
    }
    set link(other) {
        this._other = other;
    }
}
exports.MemoryWriter = MemoryWriter;
//# sourceMappingURL=MemoryWriter.js.map