/**
 * Observable
 * reference: https://github.com/zenparsing/zen-observable
 */
import { Observer, Subscription, Subscriber } from './types';
declare abstract class BaseObservable<T> {
    abstract subscribe(observer: Observer<T>): Subscription;
    abstract subscribe(onNext: (value: T) => void, onError?: (error: any) => void, onComplete?: () => void): Subscription;
}
export declare class Observable<T> extends BaseObservable<T> {
    private readonly subscriber;
    constructor(subscriber: Subscriber<T>);
    subscribe(observer: Observer<T>): Subscription;
    subscribe(onNext: (value: T) => Promise<void> | void, onError?: (error: any) => void, onComplete?: () => void): Subscription;
}
export {};
