"use strict";
/**
 * Observable
 * reference: https://github.com/zenparsing/zen-observable
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.Observable = void 0;
class BaseObservable {
}
class Observable extends BaseObservable {
    constructor(subscriber) {
        super();
        this.subscriber = subscriber;
    }
    subscribe(...args) {
        const makeComplete = (cp) => {
            return () => {
                if (subObs.closed === false) {
                    subObs.next = () => { };
                    sub.closed = true;
                    subObs.closed = true;
                    cp();
                    switch (typeof (returned)) {
                        case 'undefined': {
                            break;
                        }
                        case 'function': {
                            returned();
                            break;
                        }
                        default: {
                        }
                    }
                }
            };
        };
        let start;
        let next;
        let error;
        let complete;
        if (typeof (args[0]) === 'object') {
            start = args[0].start ? args[0].start : (sub) => { };
            next = args[0].next ? args[0].next : (value) => { };
            error = args[0].error ? args[0].error : (err) => { };
            complete = makeComplete(args[0].complete ? args[0].complete : () => { });
        }
        else {
            start = (sub) => { };
            next = args[0];
            error = args[1] ? args[1] : (err) => { };
            complete = makeComplete(args[2] ? args[2] : () => { });
        }
        const subObs = {
            closed: false,
            next,
            error,
            complete,
        };
        const returned = this.subscriber(subObs);
        let sub;
        if (typeof (returned) === 'object') {
            sub = returned;
        }
        else {
            sub = {
                closed: false,
                unsubscribe: makeComplete(() => { }),
            };
        }
        start(sub);
        return sub;
    }
}
exports.Observable = Observable;
//# sourceMappingURL=observable.js.map