"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toStringQuery = exports.stop = void 0;
/**
 * 멈춤
 * @param ms millisecond 동안 멈춤
 * @returns
 */
function stop(ms) {
    return new Promise((resolve, reject) => {
        setTimeout(resolve, ms);
    });
}
exports.stop = stop;
/**
 * url get method stringify params
 * @param params param들
 * @returns 예: ?hell=world&foo=bar
 */
function toStringQuery(params) {
    if (typeof params === 'object') {
        const keys = Object.keys(params);
        if (keys.length === 0) {
            return '';
        }
        const esc = encodeURIComponent;
        return '?' + Object.keys(params)
            .map(k => esc(k) + '=' + esc(params[k]))
            .join('&');
    }
    else {
        return '';
    }
}
exports.toStringQuery = toStringQuery;
//# sourceMappingURL=utils.js.map